# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define _without_gcj_support 1
%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/apache/ws/commons/schema/%{short_name}/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define short_name XmlSchema

%define section    free

Name:           ws-commons-XmlSchema
Version:        1.4.5
Release:        2.4%{?dist}
Epoch:          0
Summary:        XmlSchema Object Model
License:        Apache Software License 2.0
Url:            http://ws.apache.org/commons/XmlSchema/
Group:          Text Processing/Markup/XML
# svn export http://svn.apache.org/repos/asf/webservices/commons/tags/XmlSchema/XmlSchema-1.4.5/
Source0:        %{name}-%{version}-src.tar.gz
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        http://www.w3.org/XML/2004/xml-schema-test-suite/xmlschema2002-01-16/xsts-2002-01-16.tar.gz
Source4:	    %{name}-component-info.xml
Source5:        XmlSchema-1.4.5-MANIFEST.MF
Source6: 	ws-commons-XmlSchema-upload.sh

Patch0:         XmlSchema-1.4.5-disable-bundle-pom-xml.patch

BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  junit >= 0:3.8.2
BuildRequires:  xmlunit
BuildRequires:  maven-deploy-plugin
%if %{with_maven}
BuildRequires:  maven2 >= 2.0.7
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-one
BuildRequires:  maven2-plugin-resources
BuildRequires:	maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:	maven-doxia-sitetools
BuildRequires:	maven-surefire-provider-junit
BuildRequires:  plexus-velocity

%endif
#BR codehaus-stax11-api instead of geronimo-qname-1.1-api
BuildRequires:  codehaus-stax11-api
#BuildRequires:  ws-commons-java5
Requires:  jpackage-utils >= 0:1.7.3
Requires:  java >= 0:1.5.0
#R codehaus-stax11-api instead of geronimo-qname-1.1-api
Requires:  codehaus-stax11-api
#Requires:  ws-commons-java5
Requires(post):    jpackage-utils >= 0:1.7.3
Requires(postun):  jpackage-utils >= 0:1.7.3
%if %{gcj_support}
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

%description
XMLSchema is a lightweight schema object model that can be 
used to manipulate and generate XML schema representations. 
It has very few external dependancies and can be easily 
integrated into an existing project.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{short_name}-%{version}
%patch0 -p0

# 1.4.5 don't have MANIFEST.MF!!!
mkdir -p src/main/resources/META-INF/
cp %{SOURCE5} src/main/resources/META-INF/MANIFEST.MF

cp %{SOURCE1} settings.xml
%if ! %{with_maven}
mkdir -p build
pushd build
gzip -dc %{SOURCE3} | tar xf -
popd
%endif

find . -name "*.jar" -exec rm -f {} \;

%build
%if %{with_maven}
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        package javadoc:javadoc
%else
mkdir -p build/lib
build-jar-repository -s -p build/lib \
xmlunit-1.0 \

ant jar javadoc
%endif


%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
%if %{with_maven}
install -m 644 target/%{short_name}-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%else
install -m 644 build/lib/%{short_name}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%endif
%add_to_maven_depmap org.apache.ws.commons.schema %{short_name} %{version} JPP %{name}

jar -cf $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar -C src/main/java/ .

# create unprefixed and unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}
ln -sf %{name}-%{version}.jar %{name}.jar
)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %{with_maven}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%else
cp -pr build/apidoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink


%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%if %with repolib
%{__install} -d -m 755 %{buildroot}%{repodir}
%{__install} -d -m 755 %{buildroot}%{repodirlib}
%{__install} -p -m 644 %{SOURCE4} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml

%{__install} -d -m 755 %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE3} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/%{short_name}.jar
%{__cp} -p pom.xml %{buildroot}%{repodirlib}/%{short_name}.pom
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version}-sources.jar %{buildroot}%{repodirlib}/%{short_name}-sources.jar
%{__install} -p -m 755 %{SOURCE6} %{buildroot}%{repodir}/upload.sh
pushd %{buildroot}%{repodir}
./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
popd
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap 
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif


%files
%defattr(0644,root,root,0755)
%{_javadir}*/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Jan 10 2011 Yiqiao Wang <yiwang@redhat.com> 0:1.4.5-2.4
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew, add BR maven-deploy-plugin
- Add the line to find and remove any binaries

* Mon Jun 28 2010 Permaine Cheung <pcheung@redhat.com> 0:1.4.5-2.3
- BR and R codehaus-stax11-api instead of geronimo-qname

* Mon Jan 19 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.4.5-2.2.1
- Disable aot compiler


* Thu Dec 10 2009 Martha Benitez <mbenitez@redhat.com> 0:1.4.5-2.2
- Fix repolib location
- Add pom.xml to repolib
- Add sources jar file to main package and repolib
- Fix component id and artifact id in component-info.xml

* Thu Aug 06 2009 Yong Yang <yyang@redhat.com> 0:1.4.5-2.1
- Change jpackage-utils >= 0:1.7.5 to jpackage-utils >= 0:1.7.3
- Comment ws-commons-java5

* Thu Aug 06 2009 Yong Yang <yyang@redhat.com> 0:1.4.5-2
- Add repolib

* Wed Jul 29 2009 Yong Yang <yyang@redhat.com> 0:1.4.5-1
- 1.4.5
- add pom patch and MANIFEST.MF

* Fri Mar 27 2009 Ralph Apel <r.apel at r-apel.de> 0:1.4.2-1.jpp5
- Upgrade to 1.4.2

* Mon Feb 09 2009 Ralph Apel <r.apel at r-apel.de> 0:1.3.2-1.jpp5
- Upgrade to 1.3.2

* Wed May 23 2007 Ralph Apel <r.apel at r-apel.de> 0:1.3.1-1jpp
- Upgrade to 1.3.1
- Fix metadata
- Switch to m2 for build
- Add -javadoc subpackage
- Add gjc_support option
- Optionally build with straight ant and then run different tests
- Make Vendor, Distribution based on macro

* Mon May 29 2006 Fernando Nasser <fnasser@redhat.com> 0:1.0.2-2jpp
- Add missing header

* Thu May 25 2006 Deepak Bhole <dbhole@redhat.com> 0:1.0.2-1jpp
- Upgrade to v1.02

* Mon Jan 30 2006 Deepak Bhole <dbhole@redhat.com> 0:1.0-0.20060119.1jpp
- Initial build.

